<!DOCTYPE html>
<html lang="en">
<head>
    <title>Memory</title>
    <style>
        canvas {
            width: 800px;
            height: 600px;
            border: 5px solid black;
        }
        .text,input[type=text], select {
            width: 100%;
            padding: 12px 20px;
            margin: 8px 0;
            font-family: Arial;
            display: inline-block;
            border: 1px solid #ccc;
            border-radius: 4px;
            font-size: 20px;
            box-sizing: border-box;
        }

        label {
            font-family: Arial;
            font-size: 20px;
        }

        input[type=submit]:hover {
            background-color: #45a049;
        }

        .container {
            border-radius: 5px;
            background-color: #f2f2f2;
            padding: 20px;
        }
        @media screen {
            div#preloader {
                position: absolute;
                left: -9999px;
                top:  -9999px;
            }
            div#preloader img {
                display: block;
            }
        }
        @media print {
            div#preloader,
            div#preloader img {
                visibility: hidden;
                display: none;
            }
        }
        .center {
            text-align: center;
        }
        .button {
            alignment: center;
            background-color: green; /* Green */
            border: 2px solid white;
            color: white;
            font-family: Arial;
            padding: 45px 50px;
            text-align: center;
            text-decoration: none;
            display: inline-block;
            font-size: 18px;
        }
        dis {
            width: 100%;
            background-color: #4CAF50;
            color: white;
            padding: 20px;
            margin: 10px;
            border: none;
            border-radius: 4px;
            font-size: 20px;
        }
        .buttonsubmit {
            width: 100%;
            background-color: #4CAF50;
            color: white;
            padding: 14px 20px;
            margin: 8px 0;
            border: none;
            border-radius: 4px;
            font-size: 20px;
            cursor: pointer;
        }
        .button3 {
            background-color: dodgerblue;
        }
    </style>
    <script src="/socket.io/socket.io.js"></script>
</head>
<body>
Game is currently loading...
<script type="text/javascript">
    const socket = io();
    let board;
    let display;
    let players=[];
    let chatLines=[];
    const defSlots=[
        "https://svgshare.com/i/6km.svg",
        "https://sendeyo.com/up/5b01e527708ed.svg",
        "https://sendeyo.com/up/5b01e527708e3.svg",
        "https://sendeyo.com/up/5b01e529e87dd.svg",
        "https://sendeyo.com/up/5b01e52f41dfc.svg",
        "https://sendeyo.com/up/5b01e5316170c.svg",
        "https://sendeyo.com/up/5b01e53392681.svg",
        "https://sendeyo.com/up/5b01e535a2cd5.svg",
        "https://sendeyo.com/up/5b01e537cbffb.svg",
        "https://sendeyo.com/up/5b01e539e2801.svg",
        "https://sendeyo.com/up/5b01e53c08e09.svg",
        "https://sendeyo.com/up/5b01e53e1a4e9.svg",
        "https://sendeyo.com/up/5b01e5404668e.svg",
        "https://sendeyo.com/up/5b01e54275b22.svg",
        "https://sendeyo.com/up/5b01e54484b73.svg",
        "https://sendeyo.com/up/5b01e54693d73.svg",
        "https://sendeyo.com/up/5b01e548d41cc.svg",
        "https://sendeyo.com/up/5b01e54af177a.svg",
        "https://sendeyo.com/up/5b01e54d0f9d9.svg",
        "https://sendeyo.com/up/5b01e54f1fc51.svg",
        "https://sendeyo.com/up/5b01e5518b0e4.svg",
        "https://sendeyo.com/up/5b01e553bb187.svg",
        "https://sendeyo.com/up/5b01e555c821b.svg",
        "https://sendeyo.com/up/5b01e557dd564.svg",
        "https://sendeyo.com/up/5b01e559ec35a.svg",
        "https://sendeyo.com/up/5b01e55c07884.svg",
        "https://sendeyo.com/up/5b01e55e1576b.svg",
        "https://sendeyo.com/up/5b01e5627bfc6.svg",
        "https://sendeyo.com/up/5b01e5669fe5a.svg",
        "https://sendeyo.com/up/5b01e568ae949.svg",
        "https://sendeyo.com/up/5b01e56aee24b.svg",
        "https://sendeyo.com/up/5b01e56d27376.svg",
        "https://sendeyo.com/up/5b01e56f4b6ba.svg",
        "https://sendeyo.com/up/5b01e57173e8f.svg",
        "https://sendeyo.com/up/5b01e57382be3.svg",
        "https://sendeyo.com/up/5b01e575b0e0d.svg",
        "https://sendeyo.com/up/5b01e577caf3f.svg",
        "https://sendeyo.com/up/5b01e579e4227.svg",
        "https://sendeyo.com/up/5b01e57c51f8b.svg",
        "https://sendeyo.com/up/5b01e57e618f8.svg",
        "https://sendeyo.com/up/5b01e58299fe7.svg",
        "https://sendeyo.com/up/5b01e584c2cf2.svg",
        "https://sendeyo.com/up/5b01e586d8ff3.svg",
        "https://sendeyo.com/up/5b01e58918890.svg",
        "https://sendeyo.com/up/5b01e58b2861c.svg",
        "https://sendeyo.com/up/5b01e58d38924.svg"
    ];
    let adminPage;
    let gamePage;
    let defaultPage;
    let turn=0;
    let canClick=true;
    let game;
    let def;

    setupAdminPage();
    setupDefaultPage();

    socket.on('game list',function (data) {
        if(board === undefined) {
            document.body.innerHTML=defaultPage;
            let elem = document.getElementById("game");
            for(let i=0; i<data.length; i++)
                elem[i]=undefined;
            for(let i=0; i< data.length; i++) {
                let test = new Option();
                test.value = data[i];
                test.text = data[i].replace('_',' ');
                elem[i]=test;
            }
        }
    });

    socket.on('player joined', function (data) {
        console.log(data);
        players.push(data);
    });

    socket.on('sync players', function (data) {
        players=data[0];
        update();
    });

    socket.on('preload',function (data) {
        let t = '<div id="preloader">';
        for(let i=0; i<data.length; i++)
            t+= '<img src="'+data[i]+'" width="1" height="1" />';
        document.body.innerHTML+= t+'</div>';
    });

    socket.on('kick',function () {
        leaveGame();
    });

    socket.on('disable',function (data) {
        board[data]=false;
        display[data] = 'x';
        let element = document.getElementById("tile"+data);
        element.parentNode.removeChild(element);
    });

    socket.on('player scored', function () {
        players[turn][1]++;
        document.getElementById("pinfo"+turn).innerText=players[turn][0]+' '+players[turn][1];
    });

    socket.on('pfp update',function (data) {
        players[data[0][0]][2]=data[0][1];
        console.log(data);
        document.getElementById("pfp"+data[0][0]).src=data[0][1];
    });

    socket.on('player leave',function (data) {
        players.splice(data,1);
        if(turn===data)
            turn = turn+1 >= players.length ? 0 : turn+1;
        update();
    });

    socket.on('player won', function () {
        setTimeout(function () {
            document.body.innerHTML='<dis>'+players[turn][0] + ' has won the game!</dis>';
            setTimeout(function () {
                turn=0;
                leaveGame()
            }, 5000);
        }, 2000)
    });

    socket.on('turn change', function (data) {
        data=data[0];
        document.getElementById("player"+turn).attributes.style.nodeValue='position: absolute; background-color: lightskyblue; border-radius: 20px; border: none; left: '+(turn * 11+1)+'%; width: 10%; height: 90%; text-align: center';
        turn = data;
        document.getElementById("player"+turn).attributes.style.nodeValue='position: absolute; background-color: deepskyblue; border-radius: 20px; border: none; left: '+(turn * 11+1)+'%; width: 10%; height: 90%; text-align: center';
    });

    socket.on('setup', function() {
        update();
    });

    socket.on('chat',function (data) {
        chatLines.unshift(data);
        if(chatLines.length>31)
            chatLines.pop();
        if(document.getElementById("chatWindow")!==null) {
            let displayLines = "";
            for (let i = chatLines.length - 1; i >= 0; i--)
                displayLines += chatLines[i] + '\n';
            document.getElementById("chatWindow").innerText = displayLines;
        }
    });

    socket.on('alert',function (data) {
        alert(data);
    });

    socket.on('sync board', function (data) {
        board = data;
        display = Array(board.length);
        display.fill('?');
    });

    socket.on('display', function (data) {
        display[data[0]]=data[1];
        if(data[1]==='?')
            document.getElementById("tile"+data[0]).src = location.origin+'/static/mystery.svg';
        else if (data[1].startsWith("http"))
            document.getElementById("tile"+data[0]).src = data[1];
        else if (data[1].startsWith("/"))
            document.getElementById("tile"+data[0]).src = location.origin+data[1];
        else
            document.getElementById("tile"+data[0]).innerHTML = '<button type="button" class="button button3"  id="tile'+data[0]+'">' + data[1] + '</button>';
    });

    function update() {
        let typed='';
        let typing = false;
        if(document.getElementById("chat")!==null) {
            typed = document.getElementById("chat").value;
            typing = document.getElementById("chat") === document.activeElement;
        }
        setupGamePage();
        document.body.innerHTML=gamePage;
        if(typed!==undefined) document.getElementById("chat").value=typed;
        if(typing) document.activeElement = document.getElementById("chat");
    }
    function setupAdminPage() {
        for (let i = 0; i < defSlots.length; i++) {
            let t = defSlots[i];
            let choice = Math.floor(Math.random() * defSlots.length);
            defSlots[i] = defSlots[choice];
            defSlots[choice] = t;
        }
        let temp = '<div style="position:absolute;height: 94%; width: 97%;">' +
            '    <label for="name">Name</label>' +
            '    <input id="name" class="text" name="username" placeholder="My Game">' +
            '    <label for="points">Score To Win</label>' +
            '    <select id="points" name="game">' +
            '        <option value=1>1</option>' +
            '        <option value=2>2</option>' +
            '        <option value=3>3</option>' +
            '        <option value=4>4</option>' +
            '        <option value=5>5</option>' +
            '        <option value=6>6</option>' +
            '        <option value=7>7</option>' +
            '        <option value=8>8</option>' +
            '        <option value=9>9</option>' +
            '        <option value=10>10</option>' +
            '    </select>\n' +
            '    <label for="tiles">Tiles (link an image to use it)</label>';
        temp+='<br><textarea id="tiles" style="height: 65%;" class="text" name="tiles">'+defSlots.join("\n")+'</textarea>';
        temp+='<button type="button" class="button buttonsubmit" onclick="createGame()">Create</button><br><button type="button" class="button buttonsubmit" style="background-color: red;" onclick="leaveGame()">Back</button></div>';
        adminPage=temp;
    }
    function setupDefaultPage() {
        defaultPage = '' +
            '<div id="default" class="container" >' +
            '<label for="username">Name</label>' +
            '<input id="player" type="text" name="username" placeholder="Player">' +
            '<label for="game">Game</label>' +
            '<select id="game" name="game" placeholder="Player"></select>' +
            '<button type="button" class="button buttonsubmit" onclick="onSetName()">Enter</button>' +
            '</div><br><div class="container"><button type="button" class="button buttonsubmit" onclick="hostGame()">Host A Game</button></div>';
    }
    function setupGamePage() {
        let h='<div class="container" style="position: absolute; height: 66.6667%; left: 25%; width: 38%;">';
        for(let i=0; i<board.length; i++) {
            if(i%6===0) {
                if(i!==0)
                    h += '</div>';
                h += '<div class="row" style="position: absolute; width: 100%; left: 0; top: '+16.6667 * (i/6)+'%; height: 16.6667%">';
            }
            h+='<div class="tile" onclick="processBoardClick(' + i + ')" style="position: absolute; height: 100%; width: 16.6667%; left: '+16.6667 * (i%6)+'%;">';
            if (board[i]) {
                if (display[i] === '?')
                    h += '<img id="tile'+i+'" width="90%" height="90%" src="/static/mystery.svg">';
                else {
                    if (display[i].startsWith("http") || display[i].startsWith("/"))
                        h += '<img id="tile'+i+'" src="'+display[i]+'" height="90%" width="90%">';
                    else
                        h += '<button type="button" class="button button3"  id="tile'+i+'">' + display[i] + '</button>';
                }
            }
            h+='</div>';
        }
        h+= '</div>';
        h += '</div><br><div class="container" style="position: absolute; height: 20%; bottom: 0%; width: 98%; left: 0%">';
        if(players!==undefined) {
            for (let i = 0; i < players.length; i++) {
                if (turn === i)
                    h+='<div id="player'+i+'" style="position: absolute; background-color: deepskyblue; border-radius: 20px; border: none; left: '+(i * 11+1)+'%; width: 10%; height: 90%; text-align: center"><div style="position: absolute; top: 5%; left: 17%; height: 66.6667%; width: 66.6667%;"><img id="pfp'+i+'" src="'+players[i][2]+'" onclick="updatePfp()" height="100%" width="100%"></div><div id="pinfo'+i+'" style="font-family: Arial; border-radius: 10px; font-size: 32px; width: 100%; color: white; text-align: center; position: absolute; bottom: 5%">';
                else
                    h+='<div id="player'+i+'" style="position: absolute; background-color: lightskyblue; border-radius: 20px; border: none; left: '+(i * 11+1)+'%; width: 10%; height: 90%; text-align: center"><div style="position: absolute; top: 5%; left: 17%; height: 66.6667%; width: 66.6667%;"><img id="pfp'+i+'" src="'+players[i][2]+'" onclick="updatePfp()" height="100%" width="100%"></div><div id="pinfo'+i+'" style="font-family: Arial; border-radius: 10px; font-size: 32px; width: 100%; color: white; text-align: center; position: absolute; bottom: 5%">';
                h += players[i][0] + ' ' + players[i][1];
                h+='</div></div>';
            }
        }
        h+='</div>';
        let displayLines="";
        for(let i=chatLines.length-1; i>=0; i--)
            displayLines+=chatLines[i]+'<br>';
        h+='<div class="container" style="position: absolute; width: 25%; height: 66.6667%; left: 67%; top: 1%;"><div id="chatWindow" style="position:absolute; font-family: Arial; font-size: 14px; width: 100%; height: 75%;">'+displayLines+'</div><div style="position:absolute; bottom: 0;left: 10%;width: 80%; height: 17%;"><div style="position: absolute; left: 0;width: 60%;"><input type="text" id="chat"></div><div style="position: absolute; right: 0;width: 40%;"><button class="button buttonsubmit" onsubmit="sendChat()" onclick="sendChat()">Send</button></div></div></div>';
        h+='<div class="container" style="position: absolute; left: 1%; width: 20%; height: 22%; top: 22%;"><div style="position:absolute; bottom: 5%; left: 5%; width: 90%;"><button class="button buttonsubmit" style="background-color: red" onclick="leaveGame()">Leave Game</button></div><div style="position:absolute; top: 5%; left: 5%; width: 90%;"><input type="text" id="newname" placeholder="New Name"><button class="button buttonsubmit" onclick="changeName()">Change</button></div></div>';
        gamePage=h;
    }
    function onSetName(){
        def = document.body.innerHTML;
        socket.emit('player joined',document.getElementById("game").value,document.getElementById("player").value);
    }

    function processBoardClick(id) {
        if(canClick) {
            console.log('board clicked ' + Date.now());
            socket.emit('board clicked', id);
            canClick=!canClick;
            setTimeout(function () {
                canClick=true;
            }, 500)
        }
    }
    function sendChat() {
        let msg = document.getElementById("chat").value;
        document.getElementById("chat").value="";
        socket.emit('chat',msg);
    }
    function updatePfp() {
        let pfp = prompt("Change you avatar");
        if(pfp!==undefined && pfp!==null && pfp!=='' && (pfp.startsWith("http") || pfp.startsWith("/")))
            socket.emit('pfp update',pfp);
    }
    function leaveGame() {
        socket.emit('leave game');
        chatLines=[];
        board=undefined;
        display=undefined;
        socket.emit('request game list');
    }
    function changeName() {
        socket.emit('change name',document.getElementById("newname").value)
    }
    function hostGame() {
        window.name='Host Panel';
        if(adminPage===undefined)
            setupAdminPage();
        document.body.innerHTML=adminPage;
        board='hi';
    }
    function refreshGame() {
        socket.emit('refresh',game);
    }
    function deleteGame() {
        socket.emit('delete',game);
        document.body.innerHTML=adminPage;
    }
    function joinGame() {
        document.body.innerHTML=defaultPage;
        let newgame = new Option();
        newgame.value = game.replace(' ','_');
        newgame.text = game;
        document.getElementById("game")[0]=newgame;
        board=undefined;
    }

    function onSetName(){
        socket.emit('player joined',document.getElementById("game").value,document.getElementById("player").value);
    }
    function createGame() {
        game=document.getElementById("name").value;
        socket.emit('create game',
            game,
            document.getElementById("points").value, [
                document.getElementById("points").value,
                document.getElementById("tiles").value.split("\n")
            ]
        );
        document.body.innerHTML = '<button type="button" class="button buttonsubmit" onclick="refreshGame()">Restart Game</button>' +
            '<button type="button" class="button buttonsubmit" onclick="deleteGame()">Delete</button>' +
            '<button type="button" class="button buttonsubmit" onclick="joinGame()">Join</button>'
    }
</script>
</body>
</html>